(* Title:  "MathEngine/detail-step.sml"
   Author: Walther Neuper
   (c) due to copyright terms
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- interSteps [diff,integration] -----------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

"----------- interSteps [diff,integration] -----------------------------------------------------";
"----------- interSteps [diff,integration] -----------------------------------------------------";
"----------- interSteps [diff,integration] -----------------------------------------------------";
States.reset ();
CalcTree
    [(["functionTerm (x^2 + 1)", "integrateBy x", "antiDerivative FF"], 
      ("Integrate", ["integrate", "function"], ["diff", "integration"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
interSteps 1 ([1], Res);
val ((pt,p),_) = States.get_calc 1; Test_Tool.show_pt pt;
if existpt' ([1, 3], Res) pt then ()
else error "integrate.sml: interSteps on Rewrite_Set_Inst";

"----------------------------------------------------------------------------------------------";
States.reset ();
CalcTree
[(["functionTerm (Integral x^2 + 1 D x)", "integrateBy x", "antiDerivative FF"],
  ("Integrate", ["integrate", "function"], ["diff", "integration", "test"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalcHead;

fetchProposedTactic 1  (*..Apply_Method*);
autoCalculate 1 (Steps 1);
getTactic 1 ([1], Frm)  (*still empty*);

fetchProposedTactic 1  (*Rewrite_Set_Inst ''integration_rules''*);
autoCalculate 1 (Steps 1);

fetchProposedTactic 1  (*Rewrite_Set_Inst ''add_new_c''*);
autoCalculate 1 (Steps 1);

fetchProposedTactic 1  (*Rewrite_Set_Inst ''simplify_Integral''*);
autoCalculate 1 (Steps 1);

autoCalculate 1 CompleteCalc;
val ((pt,p),_) = States.get_calc 1; Test_Tool.show_pt pt;
val (Form t,_,_) = ME_Misc.pt_extract (pt, p); UnparseC.term t;
if existpt' ([3], Res) pt andalso UnparseC.term t = "c + x + 1 / 3 * x \<up> 3" then ()
else error  "integrate.sml: test-script doesnt work";

