(* Title:  Minisubplb/710-interSteps-short.sml
   Author: Walther Neuper
   (c) copyright due to lincense terms.

Shorter than Minisubplb/700-interSteps.sml +++ Detail_Step.go pt ([3,2], Res)
*)
"----------- Minisubplb/710-interSteps-short.sml -----------------------------------------------";
"----------- Minisubplb/710-interSteps-short.sml -----------------------------------------------";
"----------- Minisubplb/710-interSteps-short.sml -----------------------------------------------";
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(["equality (x+1=(2::real))", "solveFor x", "solutions L"],
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = ("Subproblem"*)
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;

(*+*)if p = ([], Res) andalso f2str f = "[x = 1]"
(*+*)then case nxt of End_Proof' => ()
(*+*)  | _ => error "calculation not finished correctly 1"
(*+*)else error "calculation not finished correctly 2";

(*+*)Test_Tool.show_pt pt;          (* 11 lines, as produced by autoCalculate CompleteCalc *)

(* called by fun interSteps ---------------------- vvvvvvvvvvvvvvvvvvvvvv *)
val ("detailrls", pt, ([2, 6], Res))    = (*case*) Detail_Step.go pt ([2], Res) (*of*);

(*+*)Test_Tool.show_pt_tac pt;     (* \<up> + ([2,1], Frm)..([2,6], Res) after ([1], Res)*)

val ("detailrls", pt, ([3, 1, 1], Res)) = (*case*) Detail_Step.go pt ([3,1], Res) (*of*);

(*+*)Test_Tool.show_pt_tac pt;     (* \<up> +++ ([3,1,1], Frm),([3,1,1], Res) after ([3,1], Frm)*)

val ("detailrls", pt, ([3, 2, 2], Res)) = (*case*) Detail_Step.go pt ([3,2], Res) (*of*);

(*+*)Test_Tool.show_pt_tac pt;     (* \<up> +++ +++  ([3,2,1], Frm)..([3,2,2], Res) after ([3,1], Res)*)

(*---------- final test ----------------------------------------------------------\\*)
if pr_ctree pr_short pt =
  ".    ----- pblobj -----\n" ^
  "1.   x + 1 = 2\n" ^
  "2.   x + 1 + - 1 * 2 = 0\n" ^
  "2.1.   x + 1 + - 1 * 2 = 0\n" ^
  "2.2.   1 + x + - 1 * 2 = 0\n" ^
  "2.3.   1 + (x + - 1 * 2) = 0\n" ^
  "2.4.   1 + (x + - 2) = 0\n" ^
  "2.5.   1 + (- 2 + x) = 0\n" ^
  "2.6.   - 2 + (1 + x) = 0\n" ^
(*([2,6], Res), - 1 + x = 0)              only by Test_Tool.show_pt_tac*)
  "3.    ----- pblobj -----\n" ^
  "3.1.   - 1 + x = 0\n" ^
  "3.1.1.   - 1 + x = 0\n" ^
(*([3,1,1], Res), x = 0 + - 1 * - 1)       only by Test_Tool.show_pt_tac*)
  "3.2.   x = 0 + - 1 * - 1\n" ^
  "3.2.1.   x = 0 + - 1 * - 1\n" ^
  "3.2.2.   x = 0 + 1\n" ^
(*([3,2,2], Res),  x = 1)                only by Test_Tool.show_pt_tac*)
  "4.   [x = 1]\n"
(*".  [x = 1]"                           only by Test_Tool.show_pt_tac*)
then () else error "intermediate steps CHANGED";

Proof_Context.theory_of (Ctree.get_ctxt pt p); (*"Test"*)
